var item_table;
var history_table;

$(document).ready( function() {

	$(".filter").click(function() {
		obj = $(this)
		obj_id = $(this).attr('id');
		obj_value = $(this).prop("checked");
		execute_live_edit(obj_id, obj_value, obj);
		run_filters();
	});

	$(".sortable").click(function() {run_sort(this, "asc");});

	run_filters();
	run_ages();
});

function goto_edit_item(element) {
	var goto_url = $(element).data("url");
	window.location.assign(goto_url);
}

function run_filters() {
	var filters = [];
	var all_filters = [];
	$(".filter").each( function() {
		var new_filter = $(this).data("filter");
		all_filters.push(new_filter);
		if($(this).prop("checked")) {
			filters.push(new_filter);
		}

	});
	//console.log(filters);
	$("#item_table > tbody > tr").each( function() {
		status_cell = $(this).find(".status");
		customer_cell = $(this).find(".customer");
		if( ! (filters.indexOf(status_cell.text()) >= 0)) {
			$(this).hide();
		}
		else {
			$(this).show();
		}
		if( ! (filters.indexOf(customer_cell.text()) >= 0  || (filters.indexOf("Work") >= 0 && all_filters.indexOf(customer_cell.text()) < 0 ) )) {
			$(this).hide();
		}
	});
}

function run_ages() {
	var now = new Date();
	$('td.latest_update').each( function() {
		var thedate = new Date($(this).text());
			$(this).removeClass('new-date aged-date old-date purge-date');
			$(this).addClass('new-date');
		if( thedate <= aged_date ) {
			$(this).removeClass('new-date aged-date old-date purge-date');
			$(this).addClass('aged-date');
		}
		if( thedate <= old_date ) {
			$(this).removeClass('new-date aged-date old-date purge-date');
			$(this).addClass('old-date');
		}
		if( thedate <= purge_date ) {
			$(this).removeClass('new-date aged-date old-date purge-date');
			$(this).addClass('purge-date');
		}
	});
	$('paper-input.latest_update').each( function() {
		var thedate = new Date($(this).val());
		console.log(thedate);
			$(this).removeClass('new-date aged-date old-date');
			$(this).addClass('new-date');
		if( thedate <= aged_date ) {
			$(this).removeClass('new-date aged-date old-date');
			$(this).addClass('aged-date');
		}
		if( thedate <= old_date ) {
			$(this).removeClass('new-date aged-date old-date');
			$(this).addClass('old-date');
		}
	});
}

function run_sort(element, sort_type) {
	column_header = $(element);
	var index = column_header.index() + 1;
	var sort_table = []
	// drop each row into an array
	$("#item_table > tbody > tr").each( function() {
		var value = $(":nth-child("+index+")", this).text();
		sort_table.push({"value": value,"row":$(this)});
	});
	// sort the array
	var sort_func = window["default_sort"];
	if (column_header.data("sortby")) {
		sort_func = window[column_header.data("sortby")];
	}
	sort_table.sort(function(a, b) { return sort_func(a, b); } );
	//sort_table.sort(function(a, b) {return a["value"].localeCompare(b["value"]);} );
	if (sort_type == "desc") {
		sort_table.reverse();
	}
	// rebuild table from the array
	table_body = $("#item_table > tbody");
	table_body.empty();
	$.each(sort_table, function() {
		table_body.append(this["row"]);
	});
	// set the column_header class
	$("#item_table > thead > tr > th.sortable").removeClass("sorted-asc sorted-desc");
	$("#item_table > thead > tr > th.sortable").unbind().click(function() {run_sort(this, "asc");})
	column_header.addClass("sorted-"+sort_type);
	if (sort_type == "desc") {
		column_header.unbind().click(function() {run_sort(this, "asc");})
	}
	else {
		column_header.unbind().click(function() {run_sort(this, "desc");})
	}
}


function date_sort(a, b) {
	c = Date.parse(a["value"]);
	d = Date.parse(b["value"]);
	return c - d;
}

function priority_sort(a, b) {
	var priority_vals = {"High": 1, "Medium": 2, "Low": 3};
	c = priority_vals[a["value"]];
	d = priority_vals[b["value"]];
	return c - d;
}

function status_sort(a, b) {
	var status_vals = {"Open": 1, "In Progress": 2, "On Hold": 3, "Closed": 4};
	c = status_vals[a["value"]];
	d = status_vals[b["value"]];
	return c - d;
}

function default_sort(a, b) {
	return a["value"].localeCompare(b["value"]);
}